/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.biffo.dms.entity.Document.DocumentsDB;
/*
import org.biffo.dms.documents.pdf.DocumentChange;
import org.biffo.dms.documents.pdf.DocumentDelete;
import org.biffo.dms.documents.pdf.DocumentMerge;
import org.biffo.dms.documents.pdf.DocumentRestore;
import org.biffo.dms.documents.pdf.DocumentSplit;
*/
import org.biffo.dms.entity.Document.DocumentsDBOS;
import org.biffo.dms.entity.Fragments.FragmentsDB;
import org.biffo.dms.entity.Logentries.LogEntriesDB;
import org.biffo.dms.entity.Relation.RelationsDB;
import org.biffo.dms.entity.Tags.TagsDB;
import org.biffo.dms.entity.Tasks.ITaskRetrieve;
import org.biffo.dms.entity.Variables.IVariablesRetrieve;
import org.biffo.dms.entity.user.Tenant.TenantsDB;
import org.biffo.dms.entity.user.Usergroups.UserGroupsDB;
import org.biffo.dms.entity.user.Userrelation.UserRelationsDB;
import org.biffo.dms.entity.user.Users.UsersDB;
import org.biffo.dms.opensearch.OpenSearchProcessing;

import de.kleinekuh.os.OsConnection;
import de.kleinekuh.os.indexes.OsIndex;
 

public class StaticLocators {

	private static final SimpleDateFormat _sdf = new SimpleDateFormat("yyyyMMddhhmmss");
	public static DocumentsDB getDocuments() {return DmsWebApplication.getApplication().getDocumentsDB();}
	public static DocumentsDBOS getDocumentsDBOS() {return DmsWebApplication.getApplication().getDocumentsDBOS();}

	
	public static RelationsDB getRelations() {return DmsWebApplication.getApplication().getRelationsDB();}
	public static TagsDB getTags() {return DmsWebApplication.getApplication().getTagsDB();}
	public static IVariablesRetrieve getVariables() {return DmsWebApplication.getApplication().getVariablesDB();}
	public static ITaskRetrieve getTasks() {return DmsWebApplication.getApplication().getTasksDB();}
	public static FragmentsDB getFragments() {return DmsWebApplication.getApplication().getFragmentsDB();}
	
	public static TenantsDB getTenants() {return DmsWebApplication.getApplication().getTenantsDB();}
	public static UserGroupsDB getUserGroups() {return DmsWebApplication.getApplication().getUserGroupsDB();}
	public static LogEntriesDB getLogEntries() {return DmsWebApplication.getApplication().getLogEntriesDB();}
	public static UsersDB getUsers() {return DmsWebApplication.getApplication().getUsersDB();}
	public static UserRelationsDB getUserRelations() {return DmsWebApplication.getApplication().getUserRelations();}
	
	public static OsConnection getOSConnection() {return DmsWebApplication.getApplication().getOsConnection();}
	public static OsIndex getOsIndex() {return  DmsWebApplication.getApplication().getOsIndex();}

	public static DmsProcessingMapper getDmsProcessingMapper() {return DmsWebApplication.getApplication().getDmsProcessingMapper();}
	public static DmsWebMessageHandler getMessageHandler() {return DmsWebApplication.getApplication().getMessageHandler();}
	public static OpenSearchProcessing getOpenSearchProcessing(){return DmsWebApplication.getApplication().getOpenSearchProcessing();}
	
	public static String getDateTimeStamp() {return _sdf.format(new Date());}
	
 	
}
