               	
 
class SearchFragment {
	constructor(itemNumber, htmlElementNumber, htmlInsidePosition, textFragment, textFragmentlength){
		this.itemNumber=itemNumber;
		this.htmlElementNumber = htmlElementNumber;
		this.htmlInsidePosition = htmlInsidePosition;
		this.textFragment = textFragment;
		this.textFragmentlength = textFragmentlength;
	}
}

 
 class PdfPage {
 
	
	constructor(idparent, id, pagenum){
		this.idparent = idparent;
		this.id = id;
		this.pagenum = pagenum;
		
		this.rotation=0;
		this.rendered=false;
		this.rendering=false;
	
		this.pdfGroupDiv =null;
		this.pdfTextLayer = null
	
		this.selected=false;
		this.editable=false;
		this.filtered=false;
		this.founditems=0;
 		this.scale=0.5;
		this.parent=null;
		
		
	}
}
 
 class PdfDocument{

	constructor(id, url, callback){
		this.id = id;
		this.url = url;
		this.callback = callback;
		
		this.renderqueue = [];
	 	this.pdfDoc = null;
		this.pdfPages=new Array();
		this.numberOfPages=0;
	
		this.docLoaded=false;
	
		this.renderType='single';
		this.scaleMulti=0.8;
		this.scaleSingle=1.5;
		this.limit=250;
		this.showpagenumbers=false;
		this.pagestorender=null;
		this.showfiltered=false;
		this.founditems=0;
		this.pagetitle='Seite';
		this.searchstring=null;
		this.searchFor=null;
		this.searchtype='s';
		this.selectable=false;
		this.context=false;
		this.drake=null;
		this.init(true);
	}
 
 
 
	
	async init(reloadpages){
		var that = this;
		that.docLoaded=false;
		pdfjsLib.getDocument(that.url).promise.then(function(pdfDoc_){
			that.pdfDoc = pdfDoc_;
			that.numberOfPages = that.pdfDoc.numPages;
			if(reloadpages){
				that.pdfPages=new Array();
				for(var i=0;i<that.numberOfPages;i++){
					var pdfpage = new PdfPage(that.id, i, i+1);
					pdfpage.rotation=-1;
					that.pdfPages.push(pdfpage);
				}
			}
		}).then(function(){
			that.docLoaded=true;
			that.processCallback("INIT_PDF", that.id);
		});
	}
	
 
	
	async renderPages(box, pagestorender ){
		if(!this.docLoaded){
			var x=0;
			while(!this.docLoaded && x<100) {
   				await new Promise(r => setTimeout(r, 100));
   				x++;
			};
		}
		this.killRender(box);
		this.pagestorender = pagestorender;
		
		
		
		if(pagestorender!=null ){
			
			if((pagestorender=='ALL' || Array.isArray(pagestorender)) && this.renderType == 'single'){			 
				this.init();
				this.renderType = 'multi';
				if(!this.docLoaded){
					var x=0;
					while(!this.docLoaded && x<100) {
   						await new Promise(r => setTimeout(r, 100));
   						x++;
					};
				}
				
			}
			 
			if(pagestorender=='ALL'){
				
				var xlimit=this.limit;
				if(this.limit==-1){
					xlimit=this.pdfPages.length;
				}

				

				for(var j= 0;j<this.pdfPages.length && j<xlimit;j++){

					if(this.showfiltered){
						if(this.pdfPages[j].filtered)this.processRenderPage( this.pdfPages[j], box);
					}else{
						this.processRenderPage( this.pdfPages[j], box);
					} 
				}
				this.processCallback('PAGE_CHANGE', this.id);
			}else if(Array.isArray(pagestorender)){
				for(var i=0;i<pagestorender.length;i++){
					var index = PdfDocument.getIndexByPageNum(pagestorender[i], this.pdfPages);
					if(this.showfiltered){
						if(this.pdfPages[index].filtered)this.processRenderPage( this.pdfPages[index], box);
					}else{
						this.processRenderPage(this.pdfPages[index], box);
					}	
				}
				this.processCallback('PAGE_CHANGE', this.id);
			}else if(!isNaN(pagestorender)){
				this.renderType = 'single';
				
				if(this.showfiltered){
					var index = PdfDocument.getIndexByPageNum(pagestorender, this.pdfPages);
					if(this.pdfPages[index].filtered){
						this.processRenderPage(this.pdfPages[index], box);
						this.pagestorender =this.pdfPages[index].pagenum;
							
					}else{
						index = this.getFirstFilteredPage(index);
						this.processRenderPage(  this.pdfPages[index], box);
						this.pagestorender =this.pdfPages[index].pagenum;
					}
				}else{
					var index = PdfDocument.getIndexByPageNum(pagestorender, this.pdfPages);
					this.processRenderPage(  this.pdfPages[index], box);
				}
				this.processCallback('PAGE_CHANGE', this.id);
			}
		}
	}
	
	 async processRenderPage(pdfpage, box){

		var that = this;
		pdfpage.rendering = true;

		(that.pdfDoc.getPage(pdfpage.pagenum).then(function(page){
	    	if(pdfpage.rendered && that.getScale()==pdfpage.scale){
				if(box!=null){
					box.appendChild(pdfpage.pdfGroupDiv);
					that.highlightSearch(that.searchstring, pdfpage, that.searchtype);
					return;	
				}
			}else{
				pdfpage.scale = that.getScale();
			}
			var viewport =  PdfDocument.getViewPort(pdfpage, page, box);
			that.setScale(viewport.scale);
	    	var pdfGroupDiv = document.createElement("div");
	    	pdfGroupDiv.setAttribute('id', 'gd'+that.id+"pg"+pdfpage.pagenum);
	    	if(box!=null)box.appendChild(pdfGroupDiv);
	    	
	    	pdfGroupDiv.onclick = function () {
				if(!pdfpage.editable && !that.selectable)return;
				var id = pdfGroupDiv.getAttribute('id');
				if(!pdfpage.selected){
					pdfpage.selected = true;
					pdfGroupDiv.classList.add('page_selected');
				}else{
					pdfpage.selected = false;
					pdfGroupDiv.classList.remove('page_selected');
				}
		
				that.processCallback("ONCLICK", id);
			};
			
			pdfGroupDiv.ondblclick = function () {
				if(that.editable)return;
				if(that.context)return;
				if(that.renderType== 'single')return;
				var id = pdfGroupDiv.getAttribute('id');
				that.pagestorender = pdfpage.pagenum;
				that.processCallback("ONDBLCLICK", id);
			};
			
			
			pdfGroupDiv.onwheel = function(event){
			    const delta = Math.sign(event.deltaY);
			    if(event.shiftKey){
					event.preventDefault();
	    			if(delta>0)that.processCallback('ZOOM_OUT');
    				if(delta<0)that.processCallback('ZOOM_IN');
    			}
    			
			};
			
	    	
	    	
	    	var pageloading = document.createElement("div");
	    	pageloading.setAttribute('class','pageloading');
			pdfGroupDiv.appendChild(pageloading);
			
			var pdfCanvas = document.createElement("canvas");
			pdfCanvas.setAttribute('id', 'cv'+that.id+"pg"+pdfpage.pagenum);
			//pdfCanvas.setAttribute('class', 'hidden');
			pdfCanvas.classList.add('hidden', 'pdfconentpage');
			pdfGroupDiv.appendChild(pdfCanvas);
			pdfGroupDiv.setAttribute('class', 'page');
			if(pdfpage.selected){
				pdfGroupDiv.classList.add('page_selected');	
			}
		    
		    if(pdfpage.founditems>0){
				pdfGroupDiv.classList.add('page_found');
			}
		    
		    
			var context = pdfCanvas.getContext('2d');
			pdfCanvas.height = viewport.height;
		    pdfCanvas.width = viewport.width;

			// Render PDF page into canvas context
			var renderContext = {
				canvasContext: context,
			    viewport: viewport
			};
			    
			var renderTask = page.render(renderContext);
		    renderTask.promise.then(function () {
				pdfpage.pdfGroupDiv = pdfGroupDiv;
				pdfGroupDiv.removeChild(pageloading);
			    pdfCanvas.classList.remove('hidden');
	    		
	    	}).then(function(){
				var pdfPageNumber = document.createElement("div");
				pdfPageNumber.innerHTML=that.pagetitle+" "+pdfpage.pagenum;
				pdfPageNumber.setAttribute('class', 'pagenumber_centered');
				if(!that.showpagenumbers){
					pdfPageNumber.classList.add('hidden');
				}
				pdfGroupDiv.appendChild(pdfPageNumber);
				return page.getTextContent();
			}).then(function(textContent){
	    		var textLayer = document.createElement("textLayer");
				textLayer.setAttribute('style', '--scale-factor:'+viewport.scale);
				textLayer.setAttribute('class', 'textLayer');
				if(pdfjsLib.version.substr(0,1)>=3){
					pdfjsLib.renderTextLayer({
						textContentSource: textContent,
						container: textLayer,
						viewport: viewport,
					}).promise.then(function(){
						pdfGroupDiv.appendChild(textLayer);
						pdfpage.pdfTextLayer = textLayer;
						that.highlightSearch(that.searchstring, pdfpage, that.searchtype);
						//that.highlightSearch(that.searchstring, pdfpage);
						/*if(that.searchstring!=null){
							var searchForArray = that.searchstring.split(' ');
							that.blub(searchForArray, pdfpage, this.splitedSearch);		
						}*/
						pdfpage.rendered = true;
						pdfpage.rendering = false;
						return textLayer;
					}); 
				}else{
					pdfjsLib.renderTextLayer({
						textContent: textContent,
						container: textLayer,
						viewport: viewport,
					}).promise.then(function(){
						pdfGroupDiv.appendChild(textLayer);
						pdfpage.pdfTextLayer = textLayer;
						
						that.highlightSearch(that.searchstring, pdfpage, that.searchtype);
						/*if(that.searchstring!=null){
							var searchForArray = that.searchstring.split(' ');
							that.blub(searchForArray, pdfpage, this.splitedSearch);	
						}*/
						
						//that.highlightSearch(that.searchstring, pdfpage);
						pdfpage.rendered = true;
						pdfpage.rendering = false;
						return textLayer;
					});
				}
				return textLayer;
			}).then(function (textlayer){
				//that.highlightSearchX(that.searchstring, pdfpage, that.searchtype);
			}).catch(function(error) {
			});
	    	that.renderqueue.push(renderTask);
		}));
		
	}
	
	static getViewPort(pdfpage, page, box){
		
		
		var scale=pdfpage.scale;
		if(scale=='X')scale=1;
		
		var desiredWidth;
		var desiredHeight;
		if(null!=box){
			desiredWidth= box.offsetWidth-34;
			desiredHeight= box.offsetHeight-20;
		}
 
		
		var vp = null; 
		if(pdfpage.rotation!=-1){
			vp = page.getViewport({ scale: scale, rotation: pdfpage.rotation});
		}else{
			vp = page.getViewport({ scale: scale});
		}
		pdfpage.rotation=vp.rotation;
		if(pdfpage.scale=='X' && box!=null){
			if(vp.height>vp.width){
				scale = desiredHeight / vp.height;
			}else{
				scale = desiredWidth / vp.width;
			}
			pdfpage.scale=scale;
		} 
		return page.getViewport({ scale: scale, rotation: pdfpage.rotation});
			
	}
	
	killRender(box){
		for(var i=0;i<this.renderqueue.length;i++){
			this.renderqueue[i].cancel();
		}
		if(null!=box){
			box.innerHTML='';
		}
		this.renderqueue = [];
	}
	
	static getIndexByPageNum(pagenum, pdfPages){
		for(var i=0;i<pdfPages.length;i++){
			if(pdfPages[i].pagenum==pagenum)return i;
		}
		return -1;
	}
	
	setScale(scale, box){
		if(scale>0.1 && scale<4){
			if(this.renderType=='single')this.scaleSingle = scale;
			else this.scaleMulti = scale
		}else if(scale==-1){
			this.scaleSingle = 'X';
		}
		if(null!=box){
			this.renderPages(box, this.pagestorender);	
		}
	}
	getScale(){
		if(this.renderType=='single') return this.scaleSingle;
		else return this.scaleMulti;
	}
	setScaleSingle(scale){
		if(scale==-1) this.scaleSingle ='X';
		else this.scaleSingle = scale;
	}
	setScaleMulti(scale){
		if(scale==-1) this.scaleMulti ='X';
		else this.scaleMulti = scale;
	}	
	
	
	setLimit(limit){
		this.limit = limit;
	}
	
	setShowPageNumbers(showpagenumbers){
		this.showpagenumbers = showpagenumbers;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].rendered){
				if(this.showpagenumbers){
					this.pdfPages[i].pdfGroupDiv.getElementsByClassName('pagenumber_centered')[0].classList.remove('hidden');
				}else{
					this.pdfPages[i].pdfGroupDiv.getElementsByClassName('pagenumber_centered')[0].classList.add('hidden');
				}
			}	
		}
	}
	
	
	getLastFilteredPage(offset){
		if(undefined==offset || null==offset )offset=this.pdfPages.length-1;
		for(var i=offset;i>=0;i--){
			if(this.pdfPages[i].filtered){
				return i;
			}
		}
		return -1;
	}
	
	getFirstFilteredPage(offset){
		if(undefined==offset || null==offset )offset=0;
		for(var i=offset;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].filtered){
				return i;
			}
		}
		return -1;
	}
	
	getNumberFilteredPages(){
		var x=0;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].filtered)x++;
		}
		return x;
		
	}
	
	
	last(box) {
		if(this.renderType=='multi') return;
		if(this.showfiltered){
			var index=this.getLastFilteredPage();
			if(index!=-1){
				this.pagestorender=this.pdfPages[index].pagenum;
				this.renderPages(box, this.pagestorender);
    			this.processCallback('PAGE_CHANGE', this.id);
			}
		}else{
			this.pagestorender=this.pdfPages[this.pdfPages.length-1].pagenum;
			this.renderPages(box, this.pagestorender);
    		this.processCallback('PAGE_CHANGE', this.id);
    	}
	};


	first(box) {
		if(this.renderType=='multi') return;
		if(this.showfiltered){
			var index=this.getFirstFilteredPage();
			if(index!=-1){
				this.pagestorender=this.pdfPages[index].pagenum;
				this.renderPages(box, this.pagestorender);
    			this.processCallback('PAGE_CHANGE', this.id);
			}
		}else{
			this.pagestorender=1;
			this.renderPages(box, this.pagestorender);
    		this.processCallback('PAGE_CHANGE', this.id);
    	}
	};
	
	increment(box, inc) {
		if(this.renderType=='multi') return;
    	if(this.showfiltered){
			var pos = -1;
			var index = PdfDocument.getIndexByPageNum(this.pagestorender, this.pdfPages);
			if(inc>0){
				pos = this.getFirstFilteredPage(index+1);
			}else if(inc<0){
				pos = this.getLastFilteredPage(index-1);
			}
			if(null==this.pdfPages[pos])return;
   			this.pagestorender=this.pdfPages[pos].pagenum;
   			this.renderPages(box, this.pagestorender);
    		this.processCallback('PAGE_CHANGE', this.id);
		}else{
    		var pos = PdfDocument.getIndexByPageNum(this.pagestorender, this.pdfPages)+inc;
			if(null==this.pdfPages[pos])return;
    		this.pagestorender=this.pdfPages[pos].pagenum;
    		this.renderPages(box, this.pagestorender);
	    	this.processCallback('PAGE_CHANGE', this.id);
	    }
	};
	
	setRotation(box, rotation){
		var selected=0;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].selected){
				selected++;
				this.pdfPages[i].selected=false;
				this.pdfPages[i].rotation=rotation;
			}
		}
		if(selected>0){
			this.refresh(box);
			this.processCallback('VIEW_CHANGED');
		}
	}
	
	refresh(box) {
	    if(this.renderType=='multi'){
			this.renderPages(box,this.pagestorender);
		}else{
			//this.renderPages(box,this.pdfPages[this.pagestorender].pagenum);
			this.renderPages(box,this.pagestorender);
		}
	};


	turnRight(box){
		var selected=0;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].selected){
				selected++;
				this.pdfPages[i].selected=false;
				this.pdfPages[i].rendered=false;
				var rotation = this.pdfPages[i].rotation+90;
				if(rotation>=360)rotation=0;
				this.pdfPages[i].rotation=rotation;
			}
		}
		if(selected>0){
			this.refresh(box);
			this.processCallback('VIEW_CHANGED');
		}
	}

	turnLeft(box){
		var selected=0;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].selected){
				selected++;
				this.pdfPages[i].selected=false;
				this.pdfPages[i].rendered=false;
				var rotation = this.pdfPages[i].rotation-90;
				if(rotation<0)rotation=270;
				this.pdfPages[i].rotation=rotation;
			}
		}
		if(selected>0){
			this.refresh(box);
			this.processCallback('VIEW_CHANGED');
		}
	} 
 
 	async setFilter(pagenums){
		this.showfiltered=true;
		if(!this.docLoaded){
			var x=0;
			while(!this.docLoaded && x<100) {
   				await new Promise(r => setTimeout(r, 100));
   				x++;
			};
		}
		for(var i=0;i<pagenums.length;i++){
			this.pdfPages[PdfDocument.getIndexByPageNum(pagenums[i], this.pdfPages)].filtered=true;
		}
	}
	
	removeFilter(){
		this.showfiltered=false;
		this.pdfDoc.clearCache();
		for(var i=0;i<this.pdfPages.length;i++){
			this.pdfPages[i].filtered=false;
		}
		this.processCallback('REMOVE_FILTER');
	}
	
	processCallback(event, id){
		if(this.callback==null) return;
		if(event=='INIT_PDF') this.callback(this.id, event, this.scaleSingle, this.scaleMulti, null, this.showfiltered, this.pagestorender, this.founditems, JSON.stringify(this.pdfPages,["pagenum","rotation","selected","founditems", "filtered"]));
		else if(event=='CLEAR_SEARCH') this.callback(this.id, event,  this.scaleSingle, this.scaleMulti, null, this.showfiltered);
		else this.callback(this.id, event, this.scaleSingle, this.scaleMulti, id, this.showfiltered, this.pagestorender, this.founditems, JSON.stringify(this.pdfPages,["pagenum","rotation","selected","founditems", "filtered"]));
	};
	
	clearSearch(withcallback, tagvalue){
		this.founditems = 0;
		this.searchstring=null;
		this.searchFor=null;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].rendered){
				this.clearSearchPage(this.pdfPages[i], tagvalue);
			}
		}
	  	if(withcallback)this.processCallback('CLEAR_SEARCH');
	};
	
	
	clearSearchPage(pdfpage, tagvalue){
		if(tagvalue==null)tagvalue='mark';
		pdfpage.founditems=0;
		pdfpage.pdfTextLayer.querySelectorAll(tagvalue).forEach(function(node) {
			var xxx = node.innerHTML;
			node.outerHTML = xxx;
		});
		var page = document.getElementById('gd'+this.id+"pg"+pdfpage.pagenum);
		if(page!=null)document.getElementById('gd'+this.id+"pg"+pdfpage.pagenum).classList.remove('page_found');
	}
	
	filterFound(box){
		var unrendered=0;
		var pagenumsfiltered = new Array();
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].rendered==false)unrendered++;
			if(this.pdfPages[i].founditems>0)pagenumsfiltered.push(this.pdfPages[i].pagenum);
			
		}
		if(pagenumsfiltered.length>0 && unrendered==0){
			this.setFilter(pagenumsfiltered);
			this.renderPages(box,  pagenumsfiltered);
			this.showfiltered = true;
		}	
		this.processCallback('FILTER_PAGES');
	}
	
	delete(box){
		var selection=[];
		var hasSelection=false;
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].selected){
				selection.push(i);
				hasSelection=true;	
			}
		}
		if(!hasSelection)return;
		for(var i=selection.length-1;i>=0;i--){
			this.pdfPages.splice(selection[i],1);
		}
		
		if(this.getNumberFilteredPages()==0){
			this.removeFilter();
		}
		
		this.processCallback('PAGE_DEETED');
		this.renderPages(box,'ALL');
	
	};
	
	setEditable(editable){
		for(var i=0;i<this.pdfPages.length;i++){
			this.pdfPages[i].editable = editable;
		}
		if(!editable)this.unselectAll();
	}
	
	setSelectable(selectable){
		this.selectable = selectable;
		if(!selectable)this.unselectAll();
	}
	
	enableContext(context){
		this.context = context;
		if(context)this.unselectAll();
	}
	
	enableDND(enable){
		if(!enable){
			if(this.drake!=null){
				this.drake.destroy();
			}
		}else{
			var that = this;
			//that.drake = dragula([document.querySelector('#pdfB'+that.id), document.querySelector('#pdfB'+that.id)]);
			that.drake = dragula([document.getElementById('pdfB'+that.id), document.getElementById('pdfB'+that.id)]);
			that.drake.on('drop', function (el) {
				that.setOrder();
			});
		}		
	}
	

	setOrder(){
		const children = document.querySelectorAll('#pdfB'+this.id+' > div');
		var temp = [];
		for (i = 0; i < children.length; i++) {
    		var ret = children[i].id.replace('gd'+this.id+'pg','');
    		for(var j=0;j<this.pdfPages.length;j++){
				if(this.pdfPages[j].pagenum===parseInt(ret)){
					temp.push(this.pdfPages[j]);	
				}
			}
		}
		this.pdfPages=[];
		for(var i=0;i<temp.length;i++){
			this.pdfPages.push(temp[i]);	
		}
		this.processCallback('NEW_ORDER');
	};
	
	unselectAll(){ 
		for(var i=0;i<this.pdfPages.length;i++){
			this.pdfPages[i].selected=false;
			if(document.getElementById('gd'+this.id+"pg"+this.pdfPages[i].pagenum)!=null){
				document.getElementById('gd'+this.id+"pg"+this.pdfPages[i].pagenum).classList.remove('page_selected');
			}
		}
		this.processCallback('VIEW_CHANGED');
 
	};
	
	async cancel(box, pagestorender){
		this.init(true);
		var x=0;
		while(!this.docLoaded && x<100) {
			await new Promise(r => setTimeout(r, 100));
			x++;
		};
		if(null!=box){
			if(null!=pagestorender)	this.renderPages(box,pagestorender);
			else this.renderPages(box,'ALL');	
		}
		this.processCallback('CANCEL');
	}
	
	
	getPage(pagenum){
		return this.pdfPages[pagenum];
	}
	
	
	/*search(searchFor) {
		if (searchFor == undefined || searchFor == null){//} || (typeof searchFor == 'string' && searchFor.length == 0)) {
			this.clearSearch(true);
			return;	
		}
		if(this.searchFor==searchFor) return;
		this.clearSearch(false);
		this.searchFor=searchFor;
		
		if(searchFor.startsWith('"') && searchFor.endsWith('"') ){
			this.searchstring = searchFor.replaceAll('"', '');
			this.searchstring = this.searchstring.replaceAll('-', '- ');
			this.searchtype='m';
		}else{
			this.searchstring = searchFor;
			this.searchtype='s';
		}
 		this.searchstring = this.searchstring.split(' ');
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].rendered) this.highlightSearch(this.searchstring, this.pdfPages[i], this.searchtype);
		}
		this.processCallback('SEARCH');
	}*/
	
	search(searchFor, tagvalue) {
		if (searchFor == undefined || searchFor == null){//} || (typeof searchFor == 'string' && searchFor.length == 0)) {
			this.clearSearch(true, tagvalue);
			return;	
		}
		if(this.searchFor==searchFor) return;
		this.clearSearch(false, tagvalue);
		this.searchFor=searchFor;
		
		if(searchFor.startsWith('"') && searchFor.endsWith('"') ){
			this.searchstring = searchFor.replaceAll('"', '');
			this.searchstring = this.searchstring.replace( /  +/g, ' ' );
			this.searchstring = this.searchstring.trim();
			//this.searchstring = this.searchstring.replaceAll('-', '- ');
			this.searchtype='m';
		}else{
			this.searchstring = searchFor.replace( /  +/g, ' ' );
			this.searchstring = this.searchstring.trim();
			this.searchtype='s';
		}
 		this.searchstring = this.searchstring.split(' ');
		for(var i=0;i<this.pdfPages.length;i++){
			if(this.pdfPages[i].rendered){
				this.highlightSearch(this.searchstring, this.pdfPages[i], this.searchtype, tagvalue);
			} 
		}
		this.processCallback('SEARCH');
	}
	
	
	SearchFragmentsSorter( p1, p2 ) {
  		if ( p1.itemNumber < p2.itemNumber )return -1;
  		if ( p1.itemNumber > p2.itemNumber )return 1;
  		return 0;
	}
	
	static fragmentExists(searchFragments, htmlFragment ){
		for(var j=0;j<searchFragments.length;j++){
			if(searchFragments[j].itemNumber==htmlFragment.itemNumber){
				return true;
			}
		}
		return false;
	}
	
	highlightSearch(searchForArray, pdfpage, searchtype, tagvalue){
		if(tagvalue==null)tagvalue='mark';
		this.clearSearchPage(pdfpage, tagvalue);
		if(searchForArray==null) return;
		var htmlFragments=[];
		var itemNumber=0;
		const htmlItems = pdfpage.pdfTextLayer.querySelectorAll('span');
 		
 		// Aufbereitung aller TextFragmente innerhalb des PDF's'
 		for(var k=0;k<htmlItems.length;k++){
			var htmlItemContent = htmlItems[k].textContent.trim();
			
			if(!htmlItemContent==''){
				var htmlInsideItems = htmlItemContent.split(' ');
				var position=0;
				for(var m=0;m<htmlInsideItems.length;m++){
					var htmlInsideItem = htmlInsideItems[m].toLowerCase();
					var htmlFragmentItem = new SearchFragment(itemNumber++, k, position, htmlInsideItem, htmlInsideItem.length);
					htmlFragments.push(htmlFragmentItem);
					position = position + htmlInsideItem.length+1;				
				}
			} 
		}
		
		var wildcard=false;
		var xArr = [];
		searchForArray.forEach(function(item, index){
 			var tempItem = item.toLowerCase();
 			wildcard=false;
 			if(searchtype=='s' && tempItem.endsWith('*')){
				wildcard=true;
				tempItem = tempItem.substring(0, tempItem.length-1).trim();
				if(tempItem=='') return;
			}
 			for(var i=0;i<htmlFragments.length;i++){
				if(searchtype=='m'){
					if(htmlFragments[i].textFragment==tempItem){
						var htmlFragment = htmlFragments[i];
						if(!PdfDocument.fragmentExists(xArr, htmlFragment )){
							xArr.push(htmlFragment);
						}
					}
				}else if(searchtype=='s'){
					if(htmlFragments[i].textFragment.startsWith(tempItem)){
						var htmlFragment = htmlFragments[i];
						if(!PdfDocument.fragmentExists(xArr, htmlFragment )){
							if(!wildcard)htmlFragment.textFragmentlength=tempItem.length;
							xArr.push(htmlFragment);
						}
					}
				}else{
					return;
				}
			}
 		});
 		xArr = xArr.sort(this.SearchFragmentsSorter);
 		var count=0;
		if(searchtype=='s'){
			for(var j=xArr.length-1;j>=0;j--){
				var htmlText = htmlItems[xArr[j].htmlElementNumber].innerHTML;
				var htmlText1 = htmlText.slice(0, xArr[j].htmlInsidePosition)
				var htmlText2 = htmlText.slice(xArr[j].htmlInsidePosition, xArr[j].htmlInsidePosition+xArr[j].textFragmentlength);
				var htmlText3 = htmlText.slice(xArr[j].htmlInsidePosition+xArr[j].textFragmentlength);
				var htmlTextNew = htmlText1  + "<"+tagvalue+">" + htmlText2+ "</"+tagvalue+">"+htmlText3;
				htmlItems[xArr[j].htmlElementNumber].innerHTML = htmlTextNew;
				count++;
			}
			
			
		}else if(searchtype='m'){
			var highlightArr = [];
			for(var i=0;i<xArr.length;i++){
				if(searchForArray.length==1){
					highlightArr.push(xArr[i]);
				}else{
					if(highlightArr.length==0)highlightArr.push(xArr[i]);
					else if(highlightArr[highlightArr.length-1].itemNumber+1==xArr[i].itemNumber){
						highlightArr.push(xArr[i]);
					}else{
						highlightArr = [];
						highlightArr.push(xArr[i]);
					}
				}
			
				if(searchForArray.length==highlightArr.length){
					for(var j=highlightArr.length-1;j>=0;j--){
						var htmlText = htmlItems[highlightArr[j].htmlElementNumber].innerHTML;
						var htmlText1 = htmlText.slice(0, highlightArr[j].htmlInsidePosition)
						var htmlText2 = htmlText.slice(highlightArr[j].htmlInsidePosition, highlightArr[j].htmlInsidePosition+highlightArr[j].textFragmentlength);
						var htmlText3 = htmlText.slice(highlightArr[j].htmlInsidePosition+highlightArr[j].textFragmentlength);
						var htmlTextNew = htmlText1  + "<"+tagvalue+">" + htmlText2+ "</"+tagvalue+">"+htmlText3;
						htmlItems[highlightArr[j].htmlElementNumber].innerHTML = htmlTextNew;
						count++;
					}
					highlightArr = [];
				}
			}
		}
		
		if(count>0 && document.getElementById('gd'+this.id+"pg"+pdfpage.pagenum)!=null){
			document.getElementById('gd'+this.id+"pg"+pdfpage.pagenum).classList.add('page_found');
			pdfpage.founditems=count;
			this.founditems = this.founditems + count;
		} 
	}

	

	
 
 	

	
}	 

 
 

  

