/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.components.pdfviewer;

import java.io.Serializable;

import org.biffo.dms.helpers.SearchHelper;

public class PdfViewerActualView implements Serializable {

 
	private static final long serialVersionUID = 1L;

	private final int documentId;
	private boolean multiView=false;
	private SearchHelper searchHelper;
	private String actPages = "1";
	private String anchorMark;
    private boolean isOnePager=false;
    private boolean isFiltered=false;
    private boolean isSearch=false;

	
	private double zoomFactorMulti=-1.0;
	private double zoomFactorSingle=-1.0;
	
	public PdfViewerActualView(int documentId) {
		this.documentId = documentId;
	}
	
	public int getDocumentId() { return documentId;}

	public boolean isMultiView() {return multiView;}
	public void setMultiView(boolean multiView) {this.multiView = multiView;}
	
	public double getZoomFactorMulti() {return zoomFactorMulti;}
	public void setZoomFactorMulti(double zoomFactorMulti) {this.zoomFactorMulti = zoomFactorMulti;}

	public double getZoomFactorSingle() {return zoomFactorSingle;}
	public void setZoomFactorSingle(double zoomFactorSingle) {this.zoomFactorSingle = zoomFactorSingle;}
	
	public SearchHelper getSearchHelper() {return searchHelper;}
	public void setSearchHelper(SearchHelper searchHelper) {this.searchHelper = searchHelper;}

	public String getActPages() {return actPages;}
	public void setActPages(String actPages) {this.actPages = actPages;}

	public boolean isOnePager() {return isOnePager;}
	public void setOnePager(boolean isOnePager) {this.isOnePager = isOnePager;}

	public boolean isFiltered() {return isFiltered;}
	public void setFiltered(boolean isFiltered) {this.isFiltered = isFiltered;}

	public boolean isSearch() {return isSearch;}
	public void setSearch(boolean isSearch) {this.isSearch = isSearch;}

	public String getAnchorMark() {return anchorMark;}
	public void setAnchorMark(String anchorMark) {this.anchorMark = anchorMark;}
	
}
