/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.components.select2;

import java.io.Serializable;

public class SelectData implements ISelectData, Serializable {


	private static final long serialVersionUID = 1L;

	@Override
	public String toString() {
		return "Data [id=" + id + ", text=" + text + ", selected=" + selected + ", disabled=" + disabled + "]";
	}
	private int id;
	private String text;
	private Boolean selected;
	private Boolean disabled;
	
	public SelectData() {}
	
	public SelectData(int id, String text,Boolean selected, Boolean disabled) {
		this.id =id;
		this.text=text;
		this.selected=selected;
		this.disabled=disabled;
	};
	
	public int getId() {return id;}
	public SelectData setId(int id) {this.id = id;return this;}
	
	public String getText() {return text;}
	public SelectData setText(String text) {this.text = text;return this;}
	
	public Boolean getSelected() {return selected;}
	public SelectData setSelected(Boolean selected) {this.selected = selected;return this;}
	
	public Boolean getDisabled() {return disabled;}
	public SelectData setDisabled(Boolean disabled) {this.disabled = disabled;return this;}
	
}
