/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.components.tagselector;

import org.biffo.dms.components.select2.SelectData;

public class TagData extends SelectData{
	
	private static final long serialVersionUID = 1L;

	public String getTitel() {return Titel;}
	public void setTitel(String titel) {Titel = titel;}

	public String getColor() {return Color;}
	public void setColor(String color) {Color = color;}

	public String getBackgroundColor() {return BackgroundColor;}
	public void setBackgroundColor(String backgroundColor) {BackgroundColor = backgroundColor;}

	private String Titel;
	private String Color;
	private String BackgroundColor;
	private String style;
	
	public TagData() {
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		if(null!=Color)sb.append("color:#"+Color+";");
		if(null!=BackgroundColor) {
			sb.append("background-color:#"+BackgroundColor+";border: 1px solid #"+BackgroundColor+";");
		}
		String temp = sb.toString();
		setStyle(temp);
		return super.toString();
	}
	
	public String getStyle() {return style;}
	public void setStyle(String style) {this.style = style;}
	
}