/**
 * 
 */
 
"use strict";  
class UploadFile{
	constructor(id, name, size, lastmodified, type, webkitRelativePath) {
	  this.id=id; 
	  this.name=name;
	  this.size=size;
	  this.lastmodified=lastmodified;
	  this.type=type;
	  this.webkitRelativePath=webkitRelativePath;
	 }
} 
 
class DmsUp{
	constructor(id, callback, uploadContainerId){
		this.id = id;
    	this.callback = callback;
    	this.uploadfiles=[];
    	this.uploadContainerId = uploadContainerId;
	}
	
	test(){
		alert(this.id);
	}
	
	clearFileList(){
		document.getElementById(this.id).value='';
		this.processCallback('CLEAR', this.id);
	}
	
	
	buildUploadList(event){
   		this.uploadfiles=[];
   		var files = document.getElementById(this.id).files; 
   		for (var i = 0, f; f = files[i]; i++) {
   			var uploadfile = new UploadFile(i, f.name, f.size, f.lastModified, f.type, f.webkitRelativePath);
   			this.uploadfiles.push(uploadfile);
   		}
   		this.processCallback(event, this.id);
   	}
   	
   	processCallback(event, id){
		if(this.callback===null) return;
		if(event==='BUILD')this.callback(event, JSON.stringify(this.uploadfiles), id);
		else if(event==='DROP')this.callback(event, JSON.stringify(this.uploadfiles), id);
		else this.callback(event, null, id);
	}
	
	
	addDND(){
		let container;
		if(this.uploadContainerId==='NA'){
			container = document.querySelector(".uploadcontainer");
		}else{
			container = document.getElementById(this.uploadContainerId);
		}
		
		if(null==container) return;
		
		container.addEventListener(
			"dragenter",
				(e) => {
					e.preventDefault();
				    e.stopPropagation();
				    container.classList.add("active");
				},
			false
		);
		container.addEventListener(
			"dragleave",
				(e) => {
					e.preventDefault();
				    e.stopPropagation();
				    container.classList.remove("active");
				},
			false
		);
		container.addEventListener(
			"dragover",
				(e) => {
					e.preventDefault();
				    e.stopPropagation();
				    container.classList.add("active");
				},
			false
		);
		container.addEventListener(
			"drop",
				(e) => {
					e.preventDefault();
				    e.stopPropagation();
				    container.classList.remove("active");
				    let draggedData = e.dataTransfer;
				    let files = draggedData.files;
				    var fileInput = document.getElementById(this.id);
				    fileInput.files = files;
				    this.buildUploadList('DROP');
		      	},
			false
		);
	}
} 

