/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.dataprovider.metrics;

import java.io.Serializable;

public class Metric implements Serializable{


	private static final long serialVersionUID = 1L;

	private int id;
	private String key;
	private Integer value;

	public Metric(int id, String key, Integer value) {
		this.id = id;
		this.key = key;
		this.value = value;
	}

	
	public int getId() {return id;}
	public void setId(int id) {this.id = id;}
	
	public String getKey() {return key;}
	public void setKey(String key) {this.key = key;}

	public Integer getValue() {return value;}
	public void setValue(Integer value) {this.value = value;}

	@Override
	public String toString() {
		return "Metric [key=" + key + ", value=" + value + "]";
	}
	
	
	
}
