/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.helpers;

import java.io.Serializable;
import java.util.BitSet;

import org.biffo.dms.entity.Tags.TagType;

public class TagObjectTypes implements Serializable{
	
	private static final long serialVersionUID = 1L;
	
	private BitSet _statusTypes=new BitSet();
	
	public TagObjectTypes(byte[] statusTypes) {
		_statusTypes = BitSet.valueOf(statusTypes);
	}
	
	public byte[] getStatusTypes() {
		_statusTypes.set(63, true);
		return _statusTypes.toByteArray();
	}
	
	public boolean isDefault() {return _statusTypes.get(TagType.DEFAULT.ordinal());}
	public void setDefault(boolean value) {_statusTypes.set(TagType.DEFAULT.ordinal(), value);}
	
	public boolean isUser() {return _statusTypes.get(TagType.USER.ordinal());}
	public void setUser(boolean value) {_statusTypes.set(TagType.USER.ordinal(), value);}
	
	public boolean isFolder() {return _statusTypes.get(TagType.FOLDER.ordinal());}
	public void setFolder(boolean value) {_statusTypes.set(TagType.FOLDER.ordinal(), value);}
	
	public boolean isRegEx() {return _statusTypes.get(TagType.REGEX.ordinal());}
	public void setRegEx(boolean value) {_statusTypes.set(TagType.REGEX.ordinal(), value);}
	
	public boolean isKI() {return _statusTypes.get(TagType.KI.ordinal());}
	public void setKI(boolean value) {_statusTypes.set(TagType.KI.ordinal(), value);}
	
	public boolean isUserGroup() {return _statusTypes.get(TagType.USERGROUP.ordinal());}
	public void setUserGroup(boolean value) {_statusTypes.set(TagType.USERGROUP.ordinal(), value);}
 
	


}
