/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.lock;

import java.io.Serializable;

 
import java.util.Date;

import org.biffo.dms.Types.EntityType;

 

public class Lock implements Serializable {

	private static final long serialVersionUID = 1L;

	public enum LockType{
		VIEW, EDIT
	}
	
	
	private int userId;
	private int entityId;
	private EntityType entityType=EntityType.UNKNOWN;
	private LockType lockType = LockType.VIEW; 
	private Date aquiredTime = new Date();
	
	public Lock(){
	}

	public int getUserId() {return userId;}
	public void setUserId(int userId) {this.userId = userId;}

	public int getEntityId() {return entityId;}
	public void setEntityId(int entityId) {this.entityId = entityId;}

	public EntityType getEntityType() {return entityType;}
	public void setEntityType(EntityType entityType) {this.entityType = entityType;}

	public Date getAquiredTime() {return aquiredTime;}
	public void setAquiredTime(Date aquiredTime) {this.aquiredTime=aquiredTime;}

	public LockType getLockType() {return lockType;}
	public void setLockType(LockType lockType) {this.lockType = lockType;}
	
	
}
