/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.models;

import org.apache.wicket.model.LoadableDetachableModel;
import org.biffo.dms.StaticLocators;
import org.biffo.dms.entity.user.Usergroups.UserGroup;
import org.biffo.dms.entity.user.Usergroups.UserGroupException;

 
 
 

 

public class UserGroupModel extends LoadableDetachableModel<UserGroup>{

	private static final long serialVersionUID = 1L;
	private int id;
	
	public UserGroupModel(){
		super();
 	}
	
	public UserGroupModel(final int id){
		super();
		this.id = id;
	}
	
	public UserGroupModel(final UserGroup entity){
		super(entity);
		this.id = entity.getId();
	}
	
	public int getId(){
		return this.id;
	}
	
	@Override
	protected UserGroup load() {
		if(this.id==-1){
			return new UserGroup();
		}else{
			try {
				return StaticLocators.getUserGroups().getEntityById(id);
			} catch (UserGroupException e) {
			}
		}
		return null;
	}
}
