/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.processQueue.tasks;

import org.apache.wicket.util.string.Strings;
import org.biffo.dms.entity.Document.Document;
import org.biffo.dms.processQueue.ProcessBridge;

public class ProcessHelpers {

	
	public static synchronized String getDocumentTitle(Document document) {
		if(Strings.isEmpty(document.getTitle())){
			return document.getDocName();	
		}else {
			return document.getTitle();
		}
	}
	
	public static synchronized void setBridgeStatusMessage(ProcessBridge bridge, String statusIn, String messageIn) {
		
		if(null!=messageIn && messageIn.length()>0) {
			if(messageIn.length()>50) {
				messageIn = messageIn.substring(0, 46)+"... ";
				messageIn="<b>"+messageIn+"</b>";
			}else {
				messageIn="<b>"+messageIn+"</b>";
			}
		}else {
			//messageIn=statusIn;
		}
		if(null!=bridge) {
			bridge.setStatus(statusIn);
			bridge.setMessage(messageIn);
		}
	}
	
}
