/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.session;

import java.util.Arrays;
import java.util.List;

public class de_DE implements ILocale{

	
	
	
	@Override
	public List<Object> getDays() {
		return Arrays.asList(new Object[] {"Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"});
	}
	
	@Override
	public List<Object> getDaysShort() {
		return Arrays.asList(new Object[] {"So","Mo","Di","Mi","Do","Fr","Sa"});
	}
	
	@Override
	public List<Object> getDaysMin() {
		return Arrays.asList(new Object[] {"So","Mo","Di","Mi","Do","Fr","Sa"});
	}
	
	@Override
	public String getDateFormat() {
		return "dd.MM.yyyy";
	}
	
	@Override
	public String getDateFormatLong() {
		return "dd.MM.yyyy HH:mm:ss";
	}
	
	@Override
	public int getWeekStart() {
		return 1;
	}
	
	@Override
	public List<Object> getMonths() {
		return Arrays.asList(new Object[] {"Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"});
	}
	
	@Override
	public List<Object> getMonthsShort() {
		return Arrays.asList(new Object[] {"Jan", "Feb", "Mär", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"});
	}

	@Override
	public String getLocaleCode() {
		return getClass().getSimpleName();
	}	

}
