/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.session.parameters;

import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;
import de.kleinekuh.entity.helpers.filterbuilder.IFilterClass;

public interface IDmsWebSessionParameters {
	
	public String getParameterName();
	public void setParameterName(String parameterName);
	
	public SortParam<String> getSortParam();
	public void setSortParam(SortParam<String> sortParam);
	
	public long getCurrentPageNumber();
	public void setCurrentPageNumber(long pageNumber);

	public IFilterClass getFilterObject();
	public void setFilterObject(IFilterClass filterClass);
	
}
