/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.session.parameters;

import java.io.Serializable;

import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;
import de.kleinekuh.entity.helpers.filterbuilder.IFilterClass;

public class LogsListParameters implements IDmsWebSessionParameters, Serializable{


	private static final long serialVersionUID = 1L;

	private transient IFilterClass _filterObject;
	private transient String parameterName;
	private transient SortParam<String> sortParam;
	private transient long currentPageNumber=0;
	

	private boolean searchVisible=false;
	
	public LogsListParameters() {
	}
	
	
	@Override
	public String getParameterName() {return parameterName;}
	@Override
	public void setParameterName(String parameterName) {this.parameterName = parameterName;}

	@Override
	public SortParam<String> getSortParam() {return sortParam;}
	@Override
	public void setSortParam(SortParam<String> sortParam) {this.sortParam = sortParam;}

	@Override
	public long getCurrentPageNumber() {return currentPageNumber;}
	@Override
	public void setCurrentPageNumber(long pageNumber) {this.currentPageNumber = pageNumber;}

	@Override
	public IFilterClass getFilterObject() {return  _filterObject;}
	@Override
	public void setFilterObject(IFilterClass filterObject) {_filterObject = filterObject;}

	
	public boolean isSearchVisible() {return searchVisible;}
	public void setSearchVisible(boolean searchVisible) {this.searchVisible = searchVisible;}

	
}
