/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.session.parameters;


public enum SessionParameterTypes {

	USERGROUPS(0, "Usergroups", StandardListParameters.class),
	USERS(1, "Users", StandardListParameters.class),
	TAGS(2, "Tags", StandardListParameters.class),
	VARIABLES(3, "Variables", StandardListParameters.class),
	DOCUMENTS(4, "Documents", DocumentsListParameters.class),
	USERLOGS(5, "Userlogs", LogsListParameters.class),
	FTP(6, "FTP", StandardListParameters.class),
	IMPORTERS(7, "Importers", StandardListParameters.class),
	DOCUMENTS_DELETED(8, "Documents Deleted", DocumentsListParameters.class),
	DOCUMENTS_ARCHIVE(9, "Documents Archive", DocumentsListParameters.class),
	DOCUMENTS_INBOX(10, "Documents Inbox", DocumentsListParameters.class),
	
	SFTP(11, "SFTP", StandardListParameters.class),
	SMTP(12, "FTP", StandardListParameters.class),
	FOLDER(13, "Folder", StandardListParameters.class),
	MODULES(14, "Modules", StandardListParameters.class),
	
	FRAGMENTS(15, "Fragments", StandardListParameters.class),
	PROCESSES(16, "Processes", StandardListParameters.class),
	
	DOCUMENT_PDF_VIEW(20, "Document PDF View", DocumentViewParameters.class),
	USER_SESSION_PARAMETERS(30, "User Session Parameters", UserSessionParameters.class),
	HOME(90, "Home", DocumentsListParameters.class),
	;
	
	
	private final int _code;
    private String _shortText;
    private final Class<?> _class;

    SessionParameterTypes(int code, String shortText, Class<?> clazz){
    	 _code = code;
    	 _shortText = shortText;
    	 _class = clazz;
    }
    
    public int getCode(){
    	return _code;
    }
    public String getShortText(){
    	return _shortText;
    }
    public Class<?> getParameterClass(){
    	return _class;
    }
    

	
	
}
