/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.session.parameters;

import java.io.Serializable;

import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;

import de.kleinekuh.entity.helpers.filterbuilder.IFilterClass;

 

public class UserSessionParameters implements IDmsWebSessionParameters, Serializable{


	private static final long serialVersionUID = 1L;

	private transient String parameterName;
	
	private boolean isAutocomplete=true;
	private boolean isCombiendQuery=true;
	
	private transient String languageCode="de_DE";
	
	@Override
	public String getParameterName() {return parameterName;}
	@Override
	public void setParameterName(String parameterName) {this.parameterName = parameterName;}

	
	@Override
	public SortParam<String> getSortParam() {return null;}
	@Override
	public void setSortParam(SortParam<String> sortParam) {}

	@Override
	public long getCurrentPageNumber() {return 0;}
	@Override
	public void setCurrentPageNumber(long pageNumber) {}

	@Override
	public IFilterClass getFilterObject() {return null;}
	@Override
	public void setFilterObject(IFilterClass filterClass) {}
	
	public boolean isAutocomplete() {return isAutocomplete;}
	public void setAutocomplete(boolean isAutocomplete) {this.isAutocomplete = isAutocomplete;}
	
	public boolean isCombiendQuery() {return isCombiendQuery;}
	public void setCombiendQuery(boolean isCombiendQuery) {this.isCombiendQuery = isCombiendQuery;}
	
	public String getLanguageCode() {return languageCode;}
	public void setLanguageCode(String languageCode) {this.languageCode = languageCode;}
	
	
	 
}
