/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.user;


public enum UserRestrictionType  {

	
	ALLOW_MODULE_SELECTION(10, "Apply Modules"),
	ALLOW_TAG_SELECTION(11, "Apply Tags"),
	ALLOW_USER_SELECTION(12, "Apply Users"),
	ALLOW_DEFAULT_UPLOAD(13, "Perform Uploads"),
	
	
	ALLOW_DELETE_DOCUMENT(30, "Delete Document"),
	ALLOW_DOWNLOAD_DOCUMENT(31, "Download Document"),
	ALLOW_SPLITT_DOCUMENT(32, "Splitt Document"),
	ALLOW_EDIT_DOCUMENT(33, "Edit Document"),
	ALLOW_UNARCHIVE_DOCUMENT(34, "Unarchvie Document"),
	ALLOW_FULLDELETE_DOCUMENT(35, "Fulldelete Document"),
	ALLOW_MERGE_DOCUMENT(36, "Fulldelete Document"),
	
	ALLOW_RESTORE_DOCUMENT(37, "Restore Document"),
	ALLOW_REPDF_DOCUMENT(38, "Re PDF Document"),
	
	 
	
	;


	private int _code;
	private String _description;

	UserRestrictionType(int code, String description){
		_code = code;
		_description = description;
	}

	public int getCode() {
		return _code;
	}
	
	public String getDescription(){
		return _description;
	}


}