/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.administration;

import org.apache.wicket.Page;
import org.apache.wicket.PageReference;
import org.biffo.dms.DmsWebApplicationPages;
import org.biffo.dms.DmsWebApplicationPages.ApplicationPage;
import org.biffo.dms.web.administration.AdministrationTabedPanel.TabContent;
import org.biffo.dms.web.template.DmsTemplate;

public class AdministrationPage extends DmsTemplate{

 
 
	private static final long serialVersionUID = 1L;
	private PageReference _pagefrom;
	
	
	public AdministrationPage(){
		this(DmsWebApplicationPages.ApplicationPage.ADMINSTRATION);
	}
	
	public AdministrationPage(ApplicationPage appPage){
		super(appPage);
		replace(new AdministrationTabedPanel(CONTENT_ID));
	}
	
	public AdministrationPage(PageReference pagefrom, TabContent selectedTab, boolean add){
		replace(new AdministrationTabedPanel(CONTENT_ID, selectedTab, add, pagefrom));
		_pagefrom = pagefrom;
	}
	
	
	@Override
	protected void onConfigure() {
		super.onConfigure();
	}
	
	public Page getPageFrom(){
		if(null!=_pagefrom) return _pagefrom.getPage();
		return null;
	}
	
}
