/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.documents.page.timeline;

import java.text.SimpleDateFormat;
import java.util.Date;

import de.kleinekuh.components.vistimeline.TimeLineItem;

public class DmsTimeLineItem extends TimeLineItem{

	private static final long serialVersionUID = 1L;
	private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
	
	private String img;
	private Object tags, users;
	
	public DmsTimeLineItem(int id, String content, Date start, Date end) {
		super(id, content, start, end);
	}
	
	public void setImg(String img) {this.img = img;}
	public String getImg() {return img;}
	
	public void setTags(Object tags) {this.tags = tags;}
	public Object getTags() {return tags;}

	public void setUsers(Object users) {this.users = users;}
	public Object getUsers() {return users;}
	
	@Override
	public String toString() {
		try {
			
			if(null!=getClassName())put("className",getClassName());
			if(null!=getAlign())put("align",getAlign());
			if(null!=getContent())put("content",getContent());
			
			if(null!=getEnd())put("end",sdf.format(getEnd()));
			if(null!=getGroup())put("group",getGroup());
			if(null!=getId())put("id",getId());

			if(null!=getSelectable())put("selectable",getSelectable());
			if(null!=getStart())put("start",sdf.format(getStart()));
			if(null!=getStyle())put("style",getStyle());

			if(null!=getSubgroup())put("subgroup",getSubgroup());
			if(null!=getTitle())put("title",getTitle());
			if(null!=getType())put("type",getType());

			if(null!=getLimitSize())put("limitSize",getLimitSize());
			if(null!=getEditable())put("editable",getEditable());
			if(null!=getEntityType())put("entityType",getEntityType());
			if(null!=getEntityId())put("entityId",getEntityId());

			
			if(null!=img)put("img",img);
			if(null!=tags)put("tags", tags);
			if(null!=users)put("users", users);
			
			if(length()>0)return super.toString();
		}catch(Exception e) {
		}
		return null;
	}
	
}
