/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.documents.page.view;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.biffo.dms.DmsWebSession;

public class ContentPanelHelper implements Serializable{

	
	private DmsWebSession _session =  DmsWebSession.getSession();
	private SimpleDateFormat _sdf = new SimpleDateFormat(_session.getLocaleParams().getDateFormatLong());
	private static final long serialVersionUID = 1L;

	private String pageSize="NA";
	private String size="NA";
	

	
	private String CreationDate;
	private String ErstelltAm;
	private String GeaendertAm;
	private String ModificationDate;
	
	public ContentPanelHelper() {}

	public String getPageSize() {return pageSize;}
	public void setPageSize(String pageSize) {this.pageSize = pageSize;}

	public String getSize() {return size;}
	public void setSize(String size) {this.size = size;}
	
	public String getCreationDate() {return CreationDate;}
	public void setCreationDate(String creationDate) {CreationDate = creationDate;}
	public void setCreationDate(Date creationDate) {
		if(null!=creationDate)	CreationDate = _sdf.format(creationDate);
	}

	public String getErstelltAm() {return ErstelltAm;}
	public void setErstelltAm(String erstelltAm) {ErstelltAm = erstelltAm;}
	public void setErstelltAm(Date erstelltAm){
		if(null!=erstelltAm)	ErstelltAm = _sdf.format(erstelltAm);
	}

	public String getGeaendertAm() {return GeaendertAm;}
	public void setGeaendertAm(String geaendertAm) {GeaendertAm = geaendertAm;}
	public void setGeaendertAm(Date geaendertAm){
		if(null!=geaendertAm)	GeaendertAm = _sdf.format(geaendertAm);
	}

	public String getModificationDate() {return ModificationDate;}
	public void setModificationDate(String modificationDate) {ModificationDate = modificationDate;}
	public void setModificationDate(Date modificationDate){
		if(null!=ModificationDate)	ModificationDate = _sdf.format(modificationDate);
	}
	
}