/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.documents.page.view;

 

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.biffo.dms.entity.Fragments.Fragment;

public class FragmentPanel extends Panel{
	 
		
	private static final long serialVersionUID = 1L;

	public FragmentPanel(String id, final Fragment fragment) {
		super(id);
 
		
		AjaxLink<String> alFragmentlink = new AjaxLink<String>("fragmentlink") {
 
			private static final long serialVersionUID = 1L;

			@Override
			public void onClick(AjaxRequestTarget target) {
				 OnFragmentViewClicked(target, fragment);
			}
		};
		alFragmentlink.setOutputMarkupId(true);
		
		Label fragmentlinklabel = new Label("fragmentlinklabel", fragment.getFragmentvalue());
		alFragmentlink.add(fragmentlinklabel);
		add(alFragmentlink);
		
	}
	protected void OnFragmentViewClicked(AjaxRequestTarget target, Fragment fragment){}
	
	
}
