/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.header;
 
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;
import org.biffo.dms.DmsWebApplication;
import org.biffo.dms.DmsWebSession;
import org.biffo.dms.auth.SignInPage;
import org.biffo.dms.web.users.UsersPage;
import org.biffo.dms.web.users.UserPanel.UserPanelType;
 

public class HeaderPanel extends Panel {

	private static final long serialVersionUID = 1L;
	final DmsWebSession _session = (DmsWebSession) DmsWebSession.get();

	public HeaderPanel(String id) {
		super(id);
		
    	Link<?> userLink = new Link<String>("userlink") {
    		private static final long serialVersionUID = 1L;
			@Override
            public void onClick() {
				UsersPage page = new UsersPage(getPage().getPageReference(), _session.getCurrentUserId(), UserPanelType.change_pw);
				setResponsePage(page);
				
            }
        };
        Label lbl = new Label("userlinkdescription", _session.getCurrentUser());
        userLink.add(lbl);
        add(userLink);
        if(DmsWebApplication.getApplication().isNoConfig())userLink.setVisible(false);

    	Link<?> logoutLink = new Link<String>("logoutlink") {
    		private static final long serialVersionUID = 1L;
			@Override
            public void onClick() {
				_session.invalidateNow();
				setResponsePage(SignInPage.class);
			}
        };
        lbl = new Label("logoutlinkdescription", "Logout");
        logoutLink.add(lbl);
        add(logoutLink);
        if(DmsWebApplication.getApplication().isNoConfig())logoutLink.setVisible(false);

	}
	
}