/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.helpers;

import java.io.Serializable;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.model.PropertyModel;

public class ErrorLabel extends Label implements Serializable{


	private static final long serialVersionUID = 1L;
	private boolean error=false;
	private String errorText="";
	
	public ErrorLabel(String id) {
		super(id);
		setDefaultModel(new PropertyModel<String>(this, "errorText"));
		setOutputMarkupId(true);
		setEscapeModelStrings(false);
	}
	public boolean isError(){return error;}
	public void clear() {errorText=null;error=false;}
	public String getErrorText() {return errorText;}
	public void setErrorText(String errorText) {this.errorText = errorText;}
}
