/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.helpers;

import org.apache.wicket.Application;
import org.apache.wicket.Component;
import org.apache.wicket.model.Model;

public class ResourceText {

	
	public static String getText(String resourceKey, Component component) {
		try {
			return Application.get().getResourceSettings().getLocalizer().getString(resourceKey, component, null, null, null, "");
		}catch(Exception e) {
		}
		return "";
	}
	
	public static Model<String> getModelText(String resourceKey, Component component) {
		try {
			return new Model<String>(Application.get().getResourceSettings().getLocalizer().getString(resourceKey, component, null, null, null, ""));
		}catch(Exception e) {
		}
		return null;
	}
	
	
	
	public static String getText(String resourceKey, Component component, Object... data) {
		try {
			
			String temp = Application.get().getResourceSettings().getLocalizer().getString(resourceKey, component, null, null, null, ""); 
			for(int i=0;i<data.length;i++) {
				String toReplace = "T"+(i+1);
				temp = temp.replaceAll(toReplace, data[i].toString());
			}
			return temp; 
		}catch(Exception e) {
		}
		return "";
	}
	
}
