/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.modals;

import org.apache.wicket.AttributeModifier;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.panel.Panel;
import org.biffo.dms.web.helpers.ResourceText;


abstract public class AbstractModalRePDFPanel extends Panel{

	private static final long serialVersionUID = 1L;
	
	public AbstractModalRePDFPanel(ModalWindow modalWindow) {
		super(modalWindow.getContentId());

		add(new Label("dialogText",ResourceText.getText("dialogText", this)));
		
		
		
		AjaxLink<Void> alRepdf = new AjaxLink<Void>("repdf"){
			private static final long serialVersionUID = 1L;
			@Override
			public void onClick(AjaxRequestTarget target){
				AbstractModalRePDFPanel.this.onRePDF(target);
			}
		};
		
		alRepdf.add(new Label("repdftext",ResourceText.getText("btnRepdfTxt", this)));
		alRepdf.add(new AttributeModifier("title", ResourceText.getText("btnRepdfTitle", this)));
		add(alRepdf);
		
		
		add(new AjaxLink<Void>("cancel"){
			private static final long serialVersionUID = 1L;
			@Override
			public void onClick(AjaxRequestTarget target){
				AbstractModalRePDFPanel.this.onCancel(target);
			}
		}.add(
			new Label("canceltext",ResourceText.getText("btnCancelTxt", this)))
		).add(
			new AttributeModifier("title", ResourceText.getText("btnCancelTitle", this))
		);
		
		
	}

	public abstract void onRePDF(AjaxRequestTarget target);
	public abstract void onCancel(AjaxRequestTarget target);


}
