/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.processes;

import java.util.Iterator;

import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.biffo.dms.DmsWebApplication;
import org.biffo.dms.processQueue.ProcessBridge;

public class DPProcesses  extends SortableDataProvider<ProcessBridge, String> {
	
	private static final long serialVersionUID = 1L;
	
	@Override
	public Iterator<? extends ProcessBridge> iterator(long start, long size) {
		return DmsWebApplication.getProcessQueue().getTasksPage((int)start, (int)size);
	}
	
	@Override
	public IModel<ProcessBridge> model(ProcessBridge object) {
		return Model.of(object);
	}
	
	public long size() {
		return DmsWebApplication.getProcessQueue().countTasks();
	}
}