/**********************************************************************
*	Copyright (C) 2024  Martin Lange
*	This file is part of biffo. OpenSource DMS
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*	info@biffo.de
*	www.biffo.de
**********************************************************************/
package org.biffo.dms.web.tags;

import org.apache.wicket.Page;
import org.apache.wicket.PageReference;
import org.biffo.dms.DmsWebApplicationPages;
import org.biffo.dms.DmsWebApplicationPages.ApplicationPage;
import org.biffo.dms.entity.Tags.Tag;
import org.biffo.dms.web.template.DmsTemplate;
 

public class TagsPage extends DmsTemplate {
 
	private static final long serialVersionUID = 1L;
	private final PageReference _pagefrom;
	
	public TagsPage(){
		this(DmsWebApplicationPages.ApplicationPage.TAGS);
	}
	
	public TagsPage(ApplicationPage appPage){
		super(appPage);
		_pagefrom = null;
		replace(new TagsListPanel(CONTENT_ID));
	}
	
	public TagsPage(PageReference pagefrom){
		super(DmsWebApplicationPages.ApplicationPage.TAGS);
		replace(new TagsListPanel(CONTENT_ID));
		_pagefrom = pagefrom;
	}
	
	
	public TagsPage(PageReference pagefrom, int tagId){
		replace(new TagPanel(CONTENT_ID, tagId,  pagefrom));
		_pagefrom = pagefrom;
	}

	public TagsPage(PageReference pagefrom, int tagId, Tag tag, int documentId){
		replace(new TagPanel(CONTENT_ID, tagId,  pagefrom, tag, documentId));
		_pagefrom = pagefrom;
	}
	
	
	@Override
	protected void onConfigure() {
		super.onConfigure();
	}
	
	public Page getPageFrom(){
		if(null!=_pagefrom) return _pagefrom.getPage();
		return null;
	}
	
}
